#include <stdlib.h>
#include <stdio.h>
#include <curses.h>
#include <ncurses.h>

#include <fcntl.h>
#include <sys/ioctl.h>
#include <time.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdarg.h>
#include <sys/io.h>
#include <stdio.h>
#include <sys/time.h>

static int m_ic_addr = 0;
static int m_vid = 0;
static int m_pid = 0;


#define READ_IC(reg)   \
	({ \
		unsigned char data = 0; \
		IOWriteByte(m_ic_addr, reg); \
		data = IOReadByte(m_ic_addr+1); \
	})

#define WRITE_IC(reg, data)   \
	({ \
		IOWriteByte(m_ic_addr, reg); \
		IOWriteByte(m_ic_addr+1, data); \
	})


unsigned char IOReadByte(unsigned int addr)
{
#if 0
	int ret = 0;
	unsigned char data = 0;

	int fd = open("/dev/port", O_RDWR | O_SYNC);

	if(fd == -1) {
		perror("IO read Open error: ");
		exit(-1);
	}

	lseek(fd, addr, SEEK_SET);
	read(fd, &data, 1);

	//printf("[hpeter]: ret: %d, LINE:%d\n", ret, __LINE__);

	close(fd);
	return data;
#else

	return inb(addr);

#endif


}

static void IOWriteByte(unsigned int addr, unsigned char data)
{
#if 0
	int ret = 0;
	int fd = open("/dev/port", O_RDWR | O_SYNC);

	if(fd == -1) {
		perror("IO write Open error: ");
		exit(-1);
	}

	lseek(fd, addr, SEEK_SET);
	write(fd, &data, 1);
	close(fd);
#else
	outb(data,addr);
#endif
}


void DeselectSIO(void)
{
	IOWriteByte(0x4e, 0xaa);
	IOWriteByte(0x2e, 0xaa);
}

int SelectSIO()
{
	int index = 0;
	int configIndex = 0;

#if 0
	unsigned char ic_bus_address[] = {0x4e, 0x2e};
	unsigned char configPort[] = {0x77, 0x67, 0x87, 0xA0};
#else
	char ic_bus_address[] = {0x4e};
	char configPort[] = {0x67};
#endif

	m_ic_addr = 0x4e;

	// auto detecting
	for(index = 0 ; index < sizeof(ic_bus_address) / sizeof(char); ++index) {
		m_ic_addr = ic_bus_address[index];

		for(configIndex = 0 ; configIndex < 4 ; ++configIndex) {
			IOWriteByte(ic_bus_address[index], configPort[configIndex]);
			IOWriteByte(ic_bus_address[index], configPort[configIndex]);


			m_vid = READ_IC(0x23) << 8 | READ_IC(0x24);
			m_pid = READ_IC(0x20) << 8 | READ_IC(0x21);

			if(m_vid == 0x1934) {
				m_ic_addr = ic_bus_address[index];
				return 0;
			}
		}

		if(configIndex < sizeof(ic_bus_address) / sizeof(char))
			break;
		else
			m_ic_addr = -1;
	}

	return -1;
}

int configureSerialPort(void){
	int index = 0;
	unsigned char data = 0;
	unsigned char ldn[] = {0x00, 0x01, 0x02, 0x03};

	for(index = 0 ; index < sizeof(ldn) / sizeof(unsigned char) ; ++index){
		WRITE_IC(0x07, ldn[index]); // select ldn
		data = READ_IC(0x70); // read share mode

		data = (data & ~(0x70) ) | 0x30;
		WRITE_IC(0x70, data);  // write share mode
		
	}
}

int main(int argc, char* argv[])
{
	int nRet = 0;


	if(iopl(3) !=0) {
		printf("Cant get previlege to access ioport!!\n");
		return 11;
	}
	

	if( (nRet = SelectSIO()) != -1){
		configureSerialPort();
		fprintf(stderr, "Fintek 216 SIO configuration successful\n");
	} else
		fprintf(stderr, "Cant Found Fintek 216 SIO\n");
	
	DeselectSIO();
	return 0;
}

